/******************************************************************
*
*	AmyGUI++ - AmyCycleList.h
*
*	Author: Erkki Tapola
*
*	$Id: amycyclelist.h 1.2 1994/04/01 08:36:50 Delta stabile Delta $
*
*	AmyCycleList is almost like AmyList (see Amymisc.h).
*	In addition to AmyList's abilities it can create
*	a "static" table of the strings contained in a list,
*	to be used in a cycle gadget. So it basically makes
*	possible to handle a cycle gadget's strings exactly
*	the same way as an AmyListview's strings.
*
******************************************************************/

#ifndef AMYCYCLELIST_H
#define AMYCYCLELIST_H

#include "amymisc.h"

class AmyCycleList : public AmyList {

    char **strings;	// A buffer to create the static table
			// which a cycle gadget requires
public:

    AmyCycleList() : AmyList() { strings = NULL; }
    ~AmyCycleList();
    const char **MakeStatic();
};

#endif
